/*--------------------------------------*/
/* 摜f[^䃋[`W             */
/* \[XR[h                       */
/*   B cm                        */
/*   ډ 摜vO~O        */
/*       SBNGCeBu               */
/*                                      */
/*  Initial     2008/07/11   T.Suzuki   */
/*  Modify      2016/12/01   T.Kimura   */
/*                                      */
/*--------------------------------------*/
/* Copyright by T.Kimura 2018           */
/*--------------------------------------*/

#include "image.h"

/*--------------------------------------------------*/
/* List1-2                                          */
/*--------------------------------------------------*/
/* 摜f[^̃̊m                         */
/*                                                  */
/* width  : 摜̉TCY                          */
/* height : 摜̏cTCY                          */
/* depth  : 摜 bit ( 8 ܂ 24)               */
/*               8 : mN                       */
/*              24 : J[                         */
/*                                                  */
/* return   ImageData \                        */
/*           width  : 摜̉TCY                */
/*           height : 摜̏cTCY                */
/*           depth  : mN or J[            */
/*           pixels : mۂ̃AhX      */
/*--------------------------------------------------*/
ImageData* createImage(int width,int height,int depth)
{
    ImageData *newimg;
    int byte_per_pixel;

    // cȌꍇ̓G[I
    if(width<0 || height<0){
        return NULL;
    }

    // Pf̃rbg(8,24ȊO̓G[)
    if(depth!=8 && depth!=24){
        return NULL;
    }

    // 摜f[^p̃̊m
    newimg=malloc(sizeof(ImageData));
    if(newimg==NULL){
        return NULL;        // mۏoȂCG[
    }

    // 1fi[̂ɕKvȃoCg߂
    byte_per_pixel=depth/8;

    // 摜f[^i[̂ɕKvȃm
    newimg->pixels=malloc(sizeof(BYTE)*byte_per_pixel*width*height);
    if(newimg->pixels==NULL) {
        free(newimg);
        return NULL;
    }

    // evpeBlݒ
    newimg->width  = width;
    newimg->height = height;
    newimg->depth  = depth;

    return newimg;
}

/*--------------------------------------------------*/
/* List1-3                                          */
/*--------------------------------------------------*/
/*  摜f[^̔p                                */
/*      mۂ摜̃̈          */
/*                                                  */
/*  img     gĂ摜f[^̍\            */
/*                                                  */
/*--------------------------------------------------*/
void disposeImage(ImageData *img)
{
    if(img->pixels!=NULL) {
        free(img->pixels);
    }
    free(img);
    return;
}

/*--------------------------------------------------*/
/* List1-4                                          */
/*--------------------------------------------------*/
/*  ʒủ摜f[^̉fl擾            */
/*                                                  */
/*  img 摜f[^Ă郁̃AhX      */
/*  x,y f̍W                                  */
/*  pix fli[                            */
/*                                                  */
/*  rerutn  0 : no error                            */
/*          -1: error                               */
/*--------------------------------------------------*/
int getPixel(ImageData *img, int x, int y, Pixel *pix)
{
    int ret=1;
    int adr;  // f̉摜̈ʒu
    int dep,val;
    BYTE *pixels;

    // ̓G[Ƃ
    if( (img==NULL) || (img->pixels==NULL) ){
        return -1;
    }

    // 摜O̍Wi[ljw肳ꂽꍇ̏ił߂摜̉fQƂj
    if(x<0) {               /* [ */
        x=0;
        ret=0;
    }
    if(x >= img->width ) {  /* E[ */
        x=img->width -1;
        ret=0;
    }
    if(y<0) {               /* [ */
        y=0;
        ret=0;
    }
    if(y >= img->height ) { /* [ */
        y=img->height -1;
        ret=0;
    }

    //
    dep = img->depth;
    adr = x + y*img->width;
    pixels = img->pixels;

    if(dep==8) {        // O[XP[̏ꍇ́ARGBׂĂ̓lZbg
        val=pixels[adr];
        pix->r=val;
        pix->g=val;
        pix->b=val;
    }
    else if(dep==24) {  // J[̏ꍇ pix ɂʒủff[^
        pixels+=(adr*3);
        pix->r=(*pixels);
        pixels++;
        pix->g=(*pixels);
        pixels++;
        pix->b=(*pixels);
    }
    else {
        return -1;
    }

    return ret;
}

/*--------------------------------------------------*/
/*  fl̕␳i͈͊O̒l͈͓Ɏ߂j      */
/*--------------------------------------------------*/
int correctValue(int val,int max)
{
    if(val<0){
        return 0;
    }

    if(val>max) {
        return max;
    }
  return val;
}

/*--------------------------------------------------*/
/* List1-5                                          */
/*--------------------------------------------------*/
/* ʒủ摜f[^̉flύX         */
/*                                                  */
/*  img 摜f[^郁̃AhX            */
/*  x,y f̍W                                  */
/*  pix Zbgfl                            */
/*                                                  */
/*  rerutn  0 : no error                            */
/*          -1: error                               */
/*--------------------------------------------------*/
int setPixel(ImageData *img,int x,int y,Pixel *pix)
{
    int adr;  // f̉摜̈ʒu
    int dep,val;
    BYTE *pixels;

    // ̓G[Ƃ
    if( (img==NULL) || (img->pixels==NULL) ){
        return -1;
    }


    // 摜O̍Ww肳ꂽȂɂȂ
    if(x<0 || x >= img->width || y<0 || y >= img->height ) {
        return 0;
    }

    dep = img->depth;
    adr = x + y*img->width;
    pixels = img->pixels;

    // mN̏ꍇ
    if(dep==8) {
        pixels[adr]=correctValue(pix->r,PIXELMAX);
#if 0
        printf("[S]MONO Image\n");
#endif
    }
    // J[̏ꍇCꂼ̐FɃf[^
    else if(dep==24) {
        pixels+=(adr*3);
        (*pixels)=correctValue(pix->r,PIXELMAX);    /* R */
        pixels++;
        (*pixels)=correctValue(pix->g,PIXELMAX);    /* G */
        pixels++;
        (*pixels)=correctValue(pix->b,PIXELMAX);    /* B */
#if 0
        printf("[S]Color Image\n");
#endif
    }
    // dep  8 ܂ 24 ȊȌꍇG[
    else {
        return -1;
    }

    return 1;
}
